from param import *

"""
Ce fichier contient toutes les méthodes nécessaires à la représentation
du monde avec ses animaux mode texte.
"""
#les représentations des différentes cases du monde
VIDE = "  "
MOUTON = "\N{SHEEP}"
LOUP = "\N{WOLF FACE}"

#les caractères utilisés pour représenter la grille
ANGLE_HAUT_GAUCHE = "\N{Box Drawings Light Down and Right}"
ANGLE_BAS_GAUCHE = "\N{Box Drawings Light Up and Right}"
ANGLE_HAUT_DROIT = "\N{Box Drawings Light Down and Left}"
ANGLE_BAS_DROIT = "\N{Box Drawings Light Up and Left}"
BORD_VERTICAL = "\N{Box Drawings Light Vertical}"
BORD_HORIZONTAL = "\N{Box Drawings Light Horizontal}"
DEBUT_LIGNE = "\N{Box Drawings Light Vertical and Right}"
FIN_LIGNE = "\N{Box Drawings Light Vertical and Left}"
DEBUT_COLONNE = "\N{Box Drawings Light Down and Horizontal}"
FIN_COLONNE = "\N{Box Drawings Light Up and Horizontal}"
CROISEMENT = "\N{Box Drawings Light Vertical and Horizontal}"

def dessiner_haut():
    """
    Fonction qui affiche la ligne du haut de la grille
    """
    texte = ANGLE_HAUT_GAUCHE
    for i in range(TAILLE - 1):
        texte += BORD_HORIZONTAL
        texte += BORD_HORIZONTAL
        texte += DEBUT_COLONNE
    texte += BORD_HORIZONTAL
    texte += BORD_HORIZONTAL
    texte += ANGLE_HAUT_DROIT
    print(texte)

def dessiner_bas():
    """
    Fonction qui affiche la ligne du bas de la grille
    """
    texte = ANGLE_BAS_GAUCHE
    for i in range(TAILLE - 1):
        texte += BORD_HORIZONTAL
        texte += BORD_HORIZONTAL
        texte += FIN_COLONNE
    texte += BORD_HORIZONTAL
    texte += BORD_HORIZONTAL
    texte += ANGLE_BAS_DROIT
    print(texte)

def dessiner_separateur():
    """
    Fonction qui affiche les lignes intermédiaire de la grille
    """
    texte = DEBUT_LIGNE
    for i in range(TAILLE - 1):
        texte += BORD_HORIZONTAL
        texte += BORD_HORIZONTAL
        texte += CROISEMENT
    texte += BORD_HORIZONTAL
    texte += BORD_HORIZONTAL
    texte += FIN_LIGNE
    print(texte)

def dessin_case(contenu):
    """
    Fonction qui détermine le caractère à afficher pour représenter
    le contenu d'une case du monde en fonction de son contenu
    """
    if contenu is None:
        return VIDE
    else:
        animal = contenu[0]
        if animal == TYPE_MOUTON:
            return MOUTON
        else:
            return LOUP
        
def dessiner_ligne(ligne):
    """
    Fonction qui affiche une ligne du monde
    """
    texte = BORD_VERTICAL
    for i in range(TAILLE - 1):
        texte += dessin_case(ligne[i])
        texte += BORD_VERTICAL
    texte += dessin_case(ligne[-1])
    texte += BORD_VERTICAL
    print(texte)

    
def dessiner_monde(monde):
    """
    Fonction qui affiche une représentation du monde
    """
    debut = True
    for num_ligne in range(len(monde)):
        if debut:
            dessiner_haut()
            debut = False
        dessiner_ligne(monde[num_ligne])
        if num_ligne < len(monde) - 1:
            dessiner_separateur()
        else:
            dessiner_bas()
